<template>
<div class="wrapper bg-gray-200">
  <nav class="fixed z-10 left-0 top-0 right-0 navbar navbar-expand-lg navbar-dark bg-dark rounded-lg ml-4 mt-1 mr-4 ">
    <div class="container-fluid">

      <button type="button" id="sidebarCollapse" class="btn btn-secondary" v-on:click="isCollapse = !isCollapse">
        <i class="fas fa-align-left"></i>
        <svg class="bi bi-justify-left" width="1em" height="1em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
          <path fill-rule="evenodd" d="M2 12.5a.5.5 0 01.5-.5h7a.5.5 0 010 1h-7a.5.5 0 01-.5-.5zm0-3a.5.5 0 01.5-.5h11a.5.5 0 010 1h-11a.5.5 0 01-.5-.5zm0-3a.5.5 0 01.5-.5h11a.5.5 0 010 1h-11a.5.5 0 01-.5-.5zm0-3a.5.5 0 01.5-.5h11a.5.5 0 010 1h-11a.5.5 0 01-.5-.5z" clip-rule="evenodd"/>
        </svg>
      </button>
      <h2 class="text-white">CHAPTERS:</h2>
      <button class="btn btn-primary" @click="addChapterClick">{{isAddingNewChapter?"CANCEL":"ADD"}}</button>

    </div>
  </nav>
  <nav id="sidebar" class="overflow-y-scroll" style="height: 100vh" v-bind:class="{'active':isCollapse}">
    <div class="row h-16 w-full">

    </div>
    <div class="sidebar-header  flex justify-between">
      <a href="/bookadmin/adminmaster" type="button" class="btn btn-primary">BOOK</a>
      <button class="btn btn-primary" @click="addBookClick">ADD</button>
    </div>
    <div class="container">
      <div class="flex justify-center m-4">
        <img class="w-full bookCover rounded-lg bg-gray-200 object-cover" :src="image" alt="Book Cover">
      </div>

      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text" id="inputGroup-sizing-default">Title</span>
        </div>
        <input v-model="title" type="text" class="form-control" aria-label="Sizing example input" aria-describedby="inputGroup-sizing-default">
      </div>
      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text" id="imageUrl">Image Url</span>
        </div>
        <input v-model="image" type="text" class="form-control" aria-label="Sizing example input" aria-describedby="inputGroup-sizing-default">
      </div>
      <div class="input-group">
        <div class="input-group-prepend">
          <span class="input-group-text">Description</span>
        </div>
        <textarea v-model="description" class="form-control" aria-label="With textarea"></textarea>
      </div>
      <div class="row flex justify-center p-4"> <button class="btn btn-primary" @click="updateBookClick">{{isAddingBook ? 'SAVE':'UPDATE'}}</button></div>
    </div>
    <div class="sidebar-header">
      <div class="row flex justify-between">
        <h3>Chapters</h3>
      </div>
    </div>
    <div class="container pl-4">
      <ol class="p-4" style="list-style: decimal" type="1">
        <a :href="'#'+item.id"  v-for="(item,index) in chapters"><li class="font-bold text-lg components ">{{item.title}}</li></a>
      </ol>
    </div>

  </nav>
  <div class="container  overflow-y-scroll pb-4" style="height: 100vh">
    <div class="row h-12 w-full">

    </div>
    <div class="row p-4" style="padding-top: 100px"  v-if="isAddingNewChapter" >
      <ChapterAdd :book-id="bookId"  v-on:saved="onSave"/>
    </div>
    <chapters :bookId="bookId"/>
  </div>

</div>
</template>


<script>
  import {mapGetters,mapActions,mapMutations} from 'vuex'
  import ChapterEditor from '~/components/ChapterEditor.vue'
  import ChapterAdd from '~/components/ChapterAdd.vue'
  import Chapters from '~/components/Chapters.vue'
  import Swal from 'sweetalert2'

export default {
    props:{},
  data(){
  return {
    book:null,
    isAddingBook:false,
    isAddingNewChapter:false,
    isCollapse:false,
    bookId:this.$route.params.id,
    title:"book title",
    description:"book description",
    image:"book image url",
    chapters:[]
  }
  },
  components:{
    ChapterEditor,
    ChapterAdd,
    Chapters
  },
  computed: {
    ...mapGetters({
        books:'Books/getBooks',
        bookRF:'Books/getBookRF'
      }
    ),

  },
  created(){
  },
  mounted(){
      if(typeof this.bookId == undefined || this.bookId == null || this.bookId=='new'){
        this.isAddingBook = true

      }else{
        this.bookRF(this.bookId).on('value',this.onData)
      }

  },
  methods:{
    ...mapMutations({
      addChapter:'Books/ADD_CHAPTER'
    }),
    getBook(){
      if (!this.bookId){
        console.log(this.$route.params.id)
        return null
      }
      this.$store.dispatch('Books/getBookById',this.bookId).then(this.onData)

    },
    onData(snapshot){
      console.log('getbookbyid',snapshot.exportVal())
      var b = snapshot.exportVal();
      this.book = b;
      this.chapters = b.chapters || []
      this.title = b.title;
      this.image = b.image;
      this.description = b.description;
    },
    addBookClick(){
      this.bookId = ""
      this.isAddingBook = true
      this.book.chapters = []
      this.title = ''
      this.description = ''
      this.image = ''
    },
    addChapterClick(){
      this.isAddingNewChapter = !this.isAddingNewChapter
      const newBook = {
        title:this.title,
        description:this.description,
        image:this.image}
      if (this.bookId == null || this.bookId == '' || this.bookId == 'new'){
        Swal.fire({
          position: 'top-center',
          icon: 'error',
          title: 'Please add book first!',
          showConfirmButton: false,
          timer: 2000
        })
        this.isAddingNewChapter = !this.isAddingNewChapter
        // this.$store.dispatch('Books/addBook',newBook).then(res =>{
        //   this.bookId = res
        //   this.bookRF(this.bookId).on('value',this.onData)
        // })
      }else{


      }
      // var id = 0
      // if (this.chapters.length>0){
      //   const ids  = Object.keys(this.chapters)
      //   id = parseInt(ids[ids.length-1])+1
      // }
      // console.log('id',id)
      // const newChapter = {title:'Chapter Title',content:'Write content here',id:id}
      // //this.addChapter({chapter:newChapter,book:this.book})
      // window.location.href = '#'+id
    },
    onSave(id){
      this.isAddingNewChapter = !this.isAddingNewChapter
      Swal.fire({
        position: 'top-center',
        icon: 'success',
        title: 'Your work has been saved',
        showConfirmButton: false,
        timer: 2000
      })
    },
    updateBookClick(){
      const newBook = {
        title:this.title,
        description:this.description,
        image:this.image

      }
      if (this.isAddingBook){
        this.$store.dispatch('Books/addBook',newBook).then(res =>{
          this.bookId = res
          this.getBook()
          this.isAddingBook = !this.isAddingBook
          location.href = `${this.bookId}`
          Swal.fire({
            position: 'top-center',
            icon: 'success',
            title: 'Your work has been saved',
            showConfirmButton: false,
            timer: 2000
          })

        })
      }else{
        this.$store.dispatch('Books/updateBook', {book:newBook, bookId:this.bookId}).then(res =>{

        })
        Swal.fire({
          position: 'top-center',
          icon: 'success',
          title: 'Your work has been Updated',
          showConfirmButton: false,
          timer: 1500
        })
      }


    }
  }
}
</script>

<style>
  .scrollable-wrapper {
    height: 100%;
    overflow-y: scroll;

  }
  .bookCover{
    width: 200px;
    height: 300px;
  }
  .chapter{
    box-shadow: #7F828B 1px 1px 1px 1px;
  }
  .wrapper {
    display: flex;
    width: 100%;

    /*align-items: stretch;*/
  }
  #sidebar {
    background: #3b8070;
    /*min-height: 100vh;*/
    min-width: 400px;
    max-width: 400px;

  }

  #sidebar.active {
    margin-left: -400px;
  }
  a[data-toggle="collapse"] {
    position: relative;
  }

  .dropdown-toggle::after {
    display: block;
    position: absolute;
    top: 50%;
    right: 20px;
    transform: translateY(-50%);
  }
  @media (max-width: 768px) {
    #sidebar {
      margin-left: -400px;
    }
    #sidebar.active {
      margin-left: 0;
    }
  }
  .container{
    position: relative;
    width: 100%;
  }
  .side-bar{
    position: absolute;
    width: 30%;
    height: 100%;
    top: 0;
    left: 0;
  }

  body {
    font-family: 'Poppins', sans-serif;
    background: #fafafa;
  }

  p {
    font-family: 'Poppins', sans-serif;
    font-size: 1.1em;
    font-weight: 300;
    line-height: 1.7em;
    color: #999;
  }

  a, a:hover, a:focus {
    color: inherit;
    text-decoration: none;
    transition: all 0.3s;
  }
  .components{
    padding: 20px 0;
    border-bottom: 1px solid #47748b;
  }
  #sidebar {
    /* don't forget to add all the previously mentioned styles here too */
    background: #7386D5;
    color: #fff;
    transition: all 0.3s;
  }

  #sidebar .sidebar-header {
    padding: 20px;
    background: #6d7fcc;
  }

  #sidebar ol.components {
    padding: 20px 0;
    border-bottom: 1px solid #47748b;
  }

  #sidebar ul p {
    color: #fff;
    padding: 10px;
  }

  #sidebar ul li a {
    padding: 10px;
    font-size: 1.1em;
    display: block;
  }
  #sidebar ul li a:hover {
    color: #7386D5;
    background: #fff;
  }

  #sidebar ul li.active > a, a[aria-expanded="true"] {
    color: #fff;
    background: #6d7fcc;
  }
  ul ul a {
    font-size: 0.9em !important;
    padding-left: 30px !important;
    background: #6d7fcc;
  }
</style>
